#include <iostream>
using namespace std;

class CaixaEletronico {
private:
    int qtd10;
    int qtd20;
    int qtd50;    
    bool podeSacar( int valor ) {
        if( valor % 10 == 0 && valor > 0 )
            return true;
        else
            return false;
    }
public:
    CaixaEletronico() :
        qtd10( 0 ), qtd20( 0 ), qtd50( 0 ) {} 
    CaixaEletronico( int qtd10, int qtd20, int qtd50 ) :
       qtd10( qtd10 ), qtd20( qtd20 ), qtd50( qtd50 ) {}
    
    void sacar( int valor ) {
        if( !podeSacar( valor ) ) {
            cout << "Valor inválido" << endl;
            return;
        }
        
        int numNotas50=0, numNotas20=0, numNotas10=0;
        numNotas50 = valor/50;
        if( qtd50 >= numNotas50 ) {
            qtd50 = qtd50 - numNotas50;
            valor = valor - numNotas50*50;
        } else {
            valor = valor - qtd50*50;
            numNotas50 = qtd50;
            qtd50 = 0;        
        }
        
        numNotas20 = valor/20;
        if( qtd20 >= numNotas20 ) {
            qtd20 = qtd20 - numNotas20;
            valor = valor - numNotas20*20;
        } else {
            valor = valor - qtd20*20;
            numNotas20 = qtd20;
            qtd20 = 0;        
        }
        
        numNotas10 = valor/10;
        if( qtd10 >= numNotas10 ) {
            qtd10 = qtd10 - numNotas10;
            valor = valor - numNotas10*10;
        } else {
            valor = valor - qtd10*10;
            numNotas10 = qtd10;
            qtd10 = 0;        
        }
        
        if( valor != 0 ) {
            cout << "Não há notas suficientes" << endl;
            qtd50 += numNotas50;
            qtd20 += numNotas20;
            qtd10 += numNotas10;
            return;
        } else {
            cout << "Saque realizado com sucesso" << endl;
            cout << numNotas50 << " x R$50" << endl;
            cout << numNotas20 << " x R$20" << endl;
            cout << numNotas10 << " x R$10" << endl;
        }
    }
    
    int getQtd50() {
        return qtd50;
    }
    int getQtd20() {
        return qtd20;
    }
    int getQtd10() {
        return qtd10;
    }
    int getMontante() {
        return 10*qtd10 + 20*qtd20 + 50*qtd50;   
    }
    
};
int main() {  
    CaixaEletronico v[10];
    v[0].sacar( 50 );
    
    
    //              R$10   R$20  R$50
    CaixaEletronico e( 0,   10,   50 ); // instaciando 'e'
    e.sacar( e.getMontante()  );
    e.sacar( 10 );
}
